//+------------------------------------------------------------------+ 
//|                Multi Level Price Alerts                          | 
//|                                                                  | 
//|   Copyright  2009, Tim Hyder aka Hiachiever                     |
//|                                                                  |
//|   PO BOX 768, Hillarys, Western Australia, Australia, 6923       |
//|                                                                  |
//|   CUSTOMISED MQ4 DEVELOPMENT                                     | 
//|   I am available for customised MQ4 development work. Please     |
//|   contact me at hiachiever@gmail.com, to discuss your  coding    |
//|   requirements. My rates are very reasonable and most jobs are   |
//|   a fixed price quote.                                           |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - hiachiever@gmail.com                                  |  
//+------------------------------------------------------------------+ 

#property copyright "Copyright  2009, Hiachiever"
#property link      "http://www.Pro4x.com"

#define vers    "30.Jan.2009"
#define Major   "2"
#define Minor   "2"

extern string NoteLevels1 = " ---        Levels to set Alerts at  ---";
extern string NoteLevels2 = " --- If Level = 0 then that alert isn't used ---";
extern double Upper1Price = 0;
extern string Upper1Note = ".";
extern double Lower1Price = 0;
extern string Lower1Note = ".";
extern double Upper2Price = 0;
extern string Upper2Note = ".";
extern double Lower2Price = 0;
extern string Lower2Note = ".";

extern string NoteGen = " -- General Options --";
extern bool RayLine = true;
extern int LineLength = 15;
extern bool AlertOnBarclose = false;

extern string NoteColors = " -- Colors for each Level --";
extern color Upper1Color = Lime;
extern color Lower1Color = Magenta;
extern color Upper2Color = LawnGreen;
extern color Lower2Color = MediumOrchid;
extern color TouchedColor = Red;

extern string NoteOptions = " --- Alert Options ---";
extern bool AlertOnCross = true;
extern string soundfile = "alert.wav";
extern bool MsgAlerts= true;
extern bool SoundAlerts= true;
extern bool eMailAlerts= false;

double Upper1bid = 0;
double Upper2bid = 0;
double Lower1bid = 0;
double Lower2bid = 0;

bool Upper1Touched = false;
bool Upper2Touched = false;
bool Lower1Touched = false;
bool Lower2Touched = false;

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
     
  //ObjectDelete("PriceLine"+Upper1Price);
  //ObjectDelete("PriceLine"+Upper2Price);
  //ObjectDelete("PriceLine"+Lower2Price);
  //ObjectDelete("PriceLine"+Lower1Price);
  Upper1Touched = false;
  Upper2Touched = false;
  Lower1Touched = false;
  Lower2Touched = false;
    
  return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("PriceLine"+Upper1Price);
   ObjectDelete("PriceLine"+Upper2Price);
   ObjectDelete("PriceLine"+Lower1Price);
   ObjectDelete("PriceLine"+Lower2Price);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   string msg;
   int BarRef;
   
   BarRef = 0;
   if (AlertOnBarclose) BarRef = 1;
   
   if(Upper1Price == 0 && Upper2Price ==0 && Lower1Price==0 && Lower2Price == 0) return(0);
   
   if(!Upper1Touched && Upper1Price != 0)
     drawLine("PriceLine"+Upper1Price,Time[LineLength], Time[0], Upper1Price, Upper1Price, 2,Upper1Color);
   
   if(!Upper2Touched && Upper2Price != 0)
     drawLine("PriceLine"+Upper2Price,Time[LineLength], Time[0], Upper2Price, Upper2Price, 2,Upper2Color);

   if(!Lower1Touched && Lower1Price != 0)
     drawLine("PriceLine"+Lower1Price,Time[LineLength], Time[0], Lower1Price, Lower1Price, 2,Lower1Color);

   if(!Lower2Touched && Lower2Price != 0)
     drawLine("PriceLine"+Lower2Price,Time[LineLength], Time[0], Lower2Price, Lower2Price, 2,Lower2Color);


   if(Upper1Price != 0 && Upper1bid !=0 && ((Close[BarRef] >= Upper1Price && Upper1bid < Upper1Price) || (Close[BarRef] <= Upper1Price && Upper1bid > Upper1Price)))
   {
       drawLine("PriceLine"+Upper1Price,Time[LineLength], Time[0], Upper1Price, Upper1Price, 2,TouchedColor);
       
      if(!Upper1Touched)
     	{
     	  msg = "Upper Price 1 Alert @ "+Upper1Price+" for "+Symbol()+" on time frame "+Period();
	     if (AlertOnCross) DoAlerts(msg + ". NOTE: " + Upper1Note,"");
        Upper1Touched = true;
  	   }
  
   }   
   

   if(Upper2Price != 0 && Upper2bid !=0 && ((Close[BarRef] >= Upper2Price && Upper2bid < Upper2Price) || (Close[BarRef] <= Upper2Price && Upper2bid > Upper2Price)))
   {
       drawLine("PriceLine"+Upper2Price,Time[LineLength], Time[0], Upper2Price, Upper2Price, 2,TouchedColor);
       
       if(!Upper2Touched)
     	{
     	  msg = "Upper Price 2 Alert @ "+Upper2Price+" for "+Symbol()+" on time frame "+Period();
	     if (AlertOnCross) DoAlerts(msg + ". NOTE: " + Upper2Note,"");
        Upper2Touched = true;
  	   }
  
   }   

   if(Lower1Price != 0 && Lower1bid !=0 && ((Close[BarRef] >= Lower1Price && Lower1bid < Lower1Price) || (Close[BarRef] <= Lower1Price && Lower1bid > Lower1Price)))
   {
       drawLine("PriceLine"+Lower1Price,Time[LineLength], Time[0], Lower1Price, Lower1Price, 2,TouchedColor);
       
       if(!Lower1Touched)
     	{
     	  msg = "Lower Price 1 Alert @ "+Lower1Price+" for "+Symbol()+" on time frame "+Period();
	     if (AlertOnCross) DoAlerts(msg + ". NOTE: " + Lower1Note,"");
        Lower1Touched = true;
  	   }
  
   }   

   if(Lower2Price != 0 && Lower2bid !=0 && ((Close[BarRef] >= Lower2Price && Lower2bid < Lower2Price) || (Close[BarRef] <= Lower2Price && Lower2bid > Lower2Price)))
   {
       drawLine("PriceLine"+Lower2Price,Time[LineLength], Time[0], Lower2Price, Lower2Price, 2,TouchedColor);
       
       if(!Lower2Touched)
     	{
     	  msg = "Lower Price 2 Alert @ "+Lower2Price+" for "+Symbol()+" on time frame "+Period();
	     if (AlertOnCross) DoAlerts(msg + ". NOTE: " + Lower2Note,"");
        Lower2Touched = true;
  	   }
  
   }   

   Upper1bid = Close[BarRef];
   Upper2bid = Close[BarRef];
   Lower1bid = Close[BarRef];
   Lower2bid = Close[BarRef];
   return(0);
  }

//+------------------------------------------------------------------+
void drawLine(string name,datetime tfrom, datetime tto, double pfrom, double pto, int width, color Col)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, tfrom, pfrom,tto,pto);
            
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
            ObjectSet(name,OBJPROP_RAY,RayLine);
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, tfrom, pfrom,tto,pto);
            
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
            ObjectSet(name,OBJPROP_RAY,RayLine);
         }
}

void DoAlerts(string MsgText, string emailsub)
{
   if (MsgAlerts) Alert(MsgText);
   if (SoundAlerts) PlaySound(soundfile);
   if (eMailAlerts) SendMail(emailsub, MsgText);
}